package com.ejie.ab79.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.DocumentosSubidos;
import com.ejie.ab79.model.plantillas.Plantillas;
import com.ejie.ab79.model.plantillas.TiposPlantilla;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * DocumentosSubidosDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class DocumentosSubidosDaoImpl implements DocumentosSubidosDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDDOCUMENTOSUBIDO", "IDTIPOPLANTILLA",
			"IDACTUACION", "NOMBREDOCUMENTO", "OIDPID", "FECHAAPORTADOPID", "OIDDOKUSI", "APORTADOEXPEDIENTE",
			"FECHAREGISTRO", "USUARIOREGISTRO", "FECHAULTMODIFICACION", "USUARIOULTMODIFICACION", "TIPODOCUMENTODESCES",
			"TIPODOCUMENTODESCEU" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<DocumentosSubidos> rwMap = new RowMapper<DocumentosSubidos>() {
		@Override
		public DocumentosSubidos mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			DocumentosSubidos documentoSubido = new DocumentosSubidos();
			documentoSubido.setIdDocumentoSubido(resultSet.getInt("IDDOCUMENTOSUBIDO"));
			documentoSubido.setIdActuacion(resultSet.getInt("IDACTUACION"));
			documentoSubido.setNombreDocumento(resultSet.getString("NOMBREDOCUMENTO"));
			documentoSubido.setOidPid(resultSet.getString("OIDPID"));
			documentoSubido.setFechaAportadoPid(resultSet.getDate("FECHAAPORTADOPID"));
			documentoSubido.setOidDokusi(resultSet.getString("OIDDOKUSI"));
			documentoSubido.setAportadoExpediente(resultSet.getInt("APORTADOEXPEDIENTE"));
			documentoSubido.setIdRelActDoc(resultSet.getInt("IDRELACTDOC"));
			documentoSubido.setEnviadoProSan(resultSet.getInt("ENVIADOPROSAN"));

			TiposPlantilla tipoPlantilla = new TiposPlantilla();
			tipoPlantilla.setIdTipoPlantilla(resultSet.getLong("IDTIPOPLANTILLA"));
			documentoSubido.setTipoPlantilla(tipoPlantilla);

			Plantillas plantilla = new Plantillas();
			plantilla.setIdPlantilla(resultSet.getInt("IDPLANTILLA"));
			plantilla.setDescripcionCastellano(resultSet.getString("PLANTILLADESCES"));
			plantilla.setDescripcionEuskera(resultSet.getString("PLANTILLADESCEU"));
			documentoSubido.setPlantilla(plantilla);

			return documentoSubido;

		}
	};

	private RowMapper<DocumentosSubidos> rwMapFind = new RowMapper<DocumentosSubidos>() {
		@Override
		public DocumentosSubidos mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			DocumentosSubidos documentoSubido = new DocumentosSubidos();
			documentoSubido.setIdDocumentoSubido(resultSet.getInt("IDDOCUMENTOSUBIDO"));
			documentoSubido.setIdActuacion(resultSet.getInt("IDACTUACION"));
			documentoSubido.setNombreDocumento(resultSet.getString("NOMBREDOCUMENTO"));
			documentoSubido.setOidPid(resultSet.getString("OIDPID"));
			documentoSubido.setFechaAportadoPid(resultSet.getDate("FECHAAPORTADOPID"));
			documentoSubido.setOidDokusi(resultSet.getString("OIDDOKUSI"));
			documentoSubido.setAportadoExpediente(resultSet.getInt("APORTADOEXPEDIENTE"));
			documentoSubido.setIdRelActDoc(resultSet.getInt("IDRELACTDOC"));
			documentoSubido.setEnviadoProSan(resultSet.getInt("ENVIADOPROSAN"));

			TiposPlantilla tipoPlantilla = new TiposPlantilla();
			tipoPlantilla.setIdTipoPlantilla(resultSet.getLong("IDTIPOPLANTILLA"));
			documentoSubido.setTipoPlantilla(tipoPlantilla);

			Plantillas plantilla = new Plantillas();
			plantilla.setIdPlantilla(resultSet.getInt("IDPLANTILLA"));
			plantilla.setDescripcionCastellano(resultSet.getString("PLANTILLADESCES"));
			plantilla.setDescripcionEuskera(resultSet.getString("PLANTILLADESCEU"));
			documentoSubido.setPlantilla(plantilla);

			return documentoSubido;

		}
	};

	private RowMapper<DocumentosSubidos> rwMapDocumentacionInspeccion = new RowMapper<DocumentosSubidos>() {
		@Override
		public DocumentosSubidos mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			DocumentosSubidos documentoSubido = new DocumentosSubidos();
			documentoSubido.setIdDocumentoSubido(resultSet.getInt("IDDOCUMENTOSUBIDO"));
			documentoSubido.setIdActuacion(resultSet.getInt("IDACTUACION"));
			documentoSubido.setNombreDocumento(resultSet.getString("NOMBREDOCUMENTO"));
			documentoSubido.setOidPid(resultSet.getString("OIDPID"));
			documentoSubido.setFechaAportadoPid(resultSet.getDate("FECHASUBIDA"));
			documentoSubido.setOidDokusi(resultSet.getString("OIDDOKUSI"));

			TiposPlantilla tipoPlantilla = new TiposPlantilla();
			tipoPlantilla.setIdTipoPlantilla(resultSet.getLong("IDTIPOPLANTILLA"));
			tipoPlantilla.setDescripcionCastellano(resultSet.getString("TIPODOCUMENTOES"));
			tipoPlantilla.setDescripcionEuskera(resultSet.getString("TIPODOCUMENTOEU"));
			documentoSubido.setTipoPlantilla(tipoPlantilla);

			return documentoSubido;

		}
	};

	private RowMapper<DocumentosSubidos> rwMapOidPid = new RowMapper<DocumentosSubidos>() {
		@Override
		public DocumentosSubidos mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			DocumentosSubidos documentoSubido = new DocumentosSubidos();
			documentoSubido.setIdDocumentoSubido(resultSet.getInt("IDDOCUMENTOSUBIDO"));
			documentoSubido.setOidPid(resultSet.getString("OIDPID"));

			return documentoSubido;

		}
	};

	private RowMapper<DocumentosSubidos> rwMapPK = new RowMapper<DocumentosSubidos>() {
		@Override
		public DocumentosSubidos mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new DocumentosSubidos(resultSet.getInt("ID_DOCUMENTO_SUBIDO"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<DocumentosSubidos>> rwMapJerarquia = new RowMapper<JerarquiaDto<DocumentosSubidos>>() {
		@Override
		public JerarquiaDto<DocumentosSubidos> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			DocumentosSubidos documentoSubido = new DocumentosSubidos();
			documentoSubido.setIdDocumentoSubido(resultSet.getInt("ID_DOCUMENTOPID"));
			documentoSubido.setIdActuacion(resultSet.getInt("IDACTUACION"));
			documentoSubido.setNombreDocumento(resultSet.getString("NOMBREDOCUMENTO"));
			documentoSubido.setOidPid(resultSet.getString("OIDPID"));
			documentoSubido.setFechaAportadoPid(resultSet.getDate("FECHA_APORTADOPID"));
			documentoSubido.setOidDokusi(resultSet.getString("OIDDOKUSI"));
			documentoSubido.setAportadoExpediente(resultSet.getInt("APORTADOEXPEDIENTE"));

			TiposPlantilla tipoPlantilla = new TiposPlantilla();
			tipoPlantilla.setIdTipoPlantilla(resultSet.getLong("IDTIPOPLANTILLA"));
			tipoPlantilla.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			tipoPlantilla.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));
			documentoSubido.setTipoPlantilla(tipoPlantilla);

			JerarquiaDto<DocumentosSubidos> jerarquia = new JerarquiaDto<DocumentosSubidos>();
			jerarquia.setModel(documentoSubido);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the DocumentosSubidos table.
	 *
	 * @param documentosSubidos
	 *            DocumentosSubidos
	 * @return DocumentosSubidos
	 */
	@Override
	public DocumentosSubidos add(DocumentosSubidos documentosSubidos) {
		String query = "INSERT INTO DOCUMENTOS_SUBIDOS (ID_DOCUMENTO_SUBIDO, ID_TIPO_PLANTILLA, NOMBRE_DOCUMENTO, OID_PID, FECHA_APORTADO_PID, OID_DOKUSI, APORTADO_EXPEDIENTE, FECHA_REGISTRO, USUARIO_REGISTRO, FECHA_ULTMODIFICACION, USUARIO_ULTMODIFICACION) VALUES (?,?,?,?,?,?,?,?,?,?,?)";
		this.jdbcTemplate.update(query, documentosSubidos.getIdDocumentoSubido(),
				documentosSubidos.getTipoPlantilla().getIdTipoPlantilla(), documentosSubidos.getNombreDocumento(),
				documentosSubidos.getOidPid(), documentosSubidos.getFechaAportadoPid(),
				documentosSubidos.getOidDokusi(), documentosSubidos.getAportadoExpediente(),
				documentosSubidos.getFechaRegistro(), documentosSubidos.getUsuarioRegistro(),
				documentosSubidos.getFechaUltmodificacion(), documentosSubidos.getUsuarioUltmodificacion());
		return documentosSubidos;
	}

	/**
	 * Updates a single row in the DocumentosSubidos table.
	 *
	 * @param documentosSubidos
	 *            DocumentosSubidos
	 * @return DocumentosSubidos
	 */
	@Override
	public DocumentosSubidos update(DocumentosSubidos documentosSubidos) {
		String query = "UPDATE DOCUMENTOS_SUBIDOS SET  APORTADO_EXPEDIENTE=?, FECHA_ULTMODIFICACION=sysdate, USUARIO_ULTMODIFICACION=? WHERE ID_DOCUMENTO_SUBIDO=?";
		this.jdbcTemplate.update(query, documentosSubidos.getAportadoExpediente(),
				documentosSubidos.getUsuarioUltmodificacion(), documentosSubidos.getIdDocumentoSubido());
		return documentosSubidos;
	}

	/**
	 * Finds a single row in the DocumentosSubidos table.
	 *
	 * @param documentosSubidos
	 *            DocumentosSubidos
	 * @return DocumentosSubidos
	 */
	@Override
	@Transactional(readOnly = true)
	public DocumentosSubidos find(DocumentosSubidos documentosSubidos) {
		String query = "SELECT t6152.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t6152.ID_TIPO_PLANTILLA IDTIPOPLANTILLA, t6152.NOMBRE_DOCUMENTO NOMBREDOCUMENTO, t6152.OID_PID OIDPID, t6152.FECHA_APORTADO_PID FECHAAPORTADOPID, t6152.OID_DOKUSI OIDDOKUSI, t6152.APORTADO_EXPEDIENTE APORTADOEXPEDIENTE, t7929.ID_REL_ACT_DOC IDRELACTDOC, t7929.ID_ACTUACION IDACTUACION, t7929.ENVIADO_PRO_SAN ENVIADOPROSAN, t6110.ID_PLANTILLA IDPLANTILLA, t6110.DESCRIPCION_CASTELLANO PLANTILLADESCES, t6110.DESCRIPCION_EUSKERA PLANTILLADESCEU FROM DOCUMENTOS_SUBIDOS t6152, REL_ACT_DOC t7929, TIPOS_PLANTILLA t6111, PLANTILLAS t6110 WHERE 1 =1 AND t6152.ID_DOCUMENTO_SUBIDO = t7929.ID_DOCUMENTO_SUBIDO AND t6152.ID_TIPO_PLANTILLA = t6111.ID_TIPO_PLANTILLA AND t6152.ID_PLANTILLA = t6110.ID_PLANTILLA(+) AND t6152.ID_DOCUMENTO_SUBIDO = ?";

		List<DocumentosSubidos> documentosSubidosList = this.jdbcTemplate.query(query, this.rwMapFind,
				documentosSubidos.getIdDocumentoSubido());
		return DataAccessUtils.uniqueResult(documentosSubidosList);
	}

	/**
	 * Removes a single row in the DocumentosSubidos table.
	 *
	 * @param documentosSubidos
	 *            DocumentosSubidos
	 * @return
	 */
	@Override
	public void remove(DocumentosSubidos documentosSubidos) {
		String query = "DELETE FROM DOCUMENTOS_SUBIDOS WHERE ID_DOCUMENTO_SUBIDO=?";
		this.jdbcTemplate.update(query, documentosSubidos.getIdDocumentoSubido());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	@Override
	public List<DocumentosSubidos> getMultiple(DocumentosSubidos filterDocumentosSubidos,
			TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterDocumentosSubidos, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, DocumentosSubidos.class,
				params, "ID_DOCUMENTO_SUBIDO");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	@Override
	@Transactional(readOnly = true)
	public List<DocumentosSubidos> findAll(DocumentosSubidos documentosSubidos, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO,t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t1.OID_PID OIDPID,t1.FECHA_APORTADO_PID FECHAAPORTADOPID,t1.OID_DOKUSI OIDDOKUSI,t1.APORTADO_EXPEDIENTE APORTADOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		query.append("FROM DOCUMENTOS_SUBIDOS t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(documentosSubidos);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					DocumentosSubidosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<DocumentosSubidos> findOidsByActuacion(Integer idActuacion) {
		StringBuilder query = new StringBuilder("SELECT t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t1.OID_PID OIDPID ");
		query.append(
				"FROM DOCUMENTOS_SUBIDOS t1, REL_ACT_DOC t2  WHERE t1.ID_DOCUMENTO_SUBIDO = t2.ID_DOCUMENTO_SUBIDO AND t2.ID_ACTUACION = ? ");

		return this.jdbcTemplate.query(query.toString(), this.rwMapOidPid, idActuacion);
	}

	@Override
	@Transactional(readOnly = true)
	public List<DocumentosSubidos> findAllLike(DocumentosSubidos documentosSubidos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t6152.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO,t6152.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t6152.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t6152.OID_PID OIDPID,t6152.FECHA_APORTADO_PID FECHAAPORTADOPID,t6152.OID_DOKUSI OIDDOKUSI,t6152.APORTADO_EXPEDIENTE APORTADOEXPEDIENTE, t7929.ID_REL_ACT_DOC IDRELACTDOC, t7929.ID_ACTUACION IDACTUACION, t7929.ENVIADO_PRO_SAN ENVIADOPROSAN, t6110.ID_PLANTILLA IDPLANTILLA, t6110.DESCRIPCION_CASTELLANO PLANTILLADESCES, t6110.DESCRIPCION_EUSKERA PLANTILLADESCEU ");
		query.append("FROM DOCUMENTOS_SUBIDOS t6152, REL_ACT_DOC t7929, TIPOS_PLANTILLA t6111, PLANTILLAS t6110 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(documentosSubidos, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t6152.ID_DOCUMENTO_SUBIDO = t7929.ID_DOCUMENTO_SUBIDO AND t6152.ID_TIPO_PLANTILLA = t6111.ID_TIPO_PLANTILLA AND t6152.ID_PLANTILLA = t6110.ID_PLANTILLA(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					DocumentosSubidosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<DocumentosSubidos> findDocumentacionInspeccion(DocumentosSubidos filterDocumentosSubidos,
			TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT t4.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO, t4.NOMBRE_DOCUMENTO NOMBREDOCUMENTO, t2.ID_ACTUACION IDACTUACION, t5.ID_TIPO_PLANTILLA IDTIPOPLANTILLA, t5.DESCRIPCION_CASTELLANO TIPODOCUMENTOES, t5.DESCRIPCION_EUSKERA TIPODOCUMENTOEU, t4.FECHA_APORTADO_PID FECHASUBIDA, t4.OID_PID OIDPID, t4.OID_DOKUSI OIDDOKUSI FROM INSPECCIONES t1, ACTUACIONES t2, REL_ACT_DOC t3, DOCUMENTOS_SUBIDOS t4, TIPOS_PLANTILLA t5 WHERE t1.ID_INSPECCION = t2.ID_INSPECCION AND t2.ID_ACTUACION = t3.ID_ACTUACION AND t3.ID_DOCUMENTO_SUBIDO = t4.ID_DOCUMENTO_SUBIDO AND t4.ID_TIPO_PLANTILLA = t5.ID_TIPO_PLANTILLA AND t1.ID_INSPECCION = ?");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					DocumentosSubidosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMapDocumentacionInspeccion,
				filterDocumentosSubidos.getIdInspeccion());
	}

	@Override
	@Transactional(readOnly = true)
	public Long findAllCount(DocumentosSubidos documentosSubidos) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM DOCUMENTOS_SUBIDOS t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(documentosSubidos);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	@Override
	@Transactional(readOnly = true)
	public Long findAllLikeCount(DocumentosSubidos documentosSubidos, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT COUNT(1) FROM DOCUMENTOS_SUBIDOS t6152, REL_ACT_DOC t7929, TIPOS_PLANTILLA t6111, PLANTILLAS t6110 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(documentosSubidos, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t6152.ID_DOCUMENTO_SUBIDO = t7929.ID_DOCUMENTO_SUBIDO AND t6152.ID_TIPO_PLANTILLA = t6111.ID_TIPO_PLANTILLA AND t6152.ID_PLANTILLA = t6110.ID_PLANTILLA(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	@Override
	public Long findDocumentacionInspeccionCount(DocumentosSubidos documentosSubidos) {
		StringBuilder query = new StringBuilder(
				"SELECT COUNT(1) FROM INSPECCIONES t1, ACTUACIONES t2, REL_ACT_DOC t3, DOCUMENTOS_SUBIDOS t4, TIPOS_PLANTILLA t5 WHERE t1.ID_INSPECCION = t2.ID_INSPECCION AND t2.ID_ACTUACION = t3.ID_ACTUACION AND t3.ID_DOCUMENTO_SUBIDO = t4.ID_DOCUMENTO_SUBIDO AND t4.ID_TIPO_PLANTILLA = t5.ID_TIPO_PLANTILLA AND t1.ID_INSPECCION = ?");
		List<Object> params = new ArrayList<Object>();
		params.add(documentosSubidos.getIdInspeccion());
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	@Override
	public List<TableRowDto<DocumentosSubidos>> reorderSelection(DocumentosSubidos documentosSubidos,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO,t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t1.OID_PID OIDPID,t1.FECHA_APORTADO_PID FECHAAPORTADOPID,t1.OID_DOKUSI OIDDOKUSI,t1.APORTADO_EXPEDIENTE APORTADOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM DOCUMENTOS_SUBIDOS t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(documentosSubidos, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				DocumentosSubidos.class, filterParamList, "ID_DOCUMENTO_SUBIDO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<DocumentosSubidos>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	@Override
	public List<TableRowDto<DocumentosSubidos>> search(DocumentosSubidos filterParams, DocumentosSubidos searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO,t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t1.OID_PID OIDPID,t1.FECHA_APORTADO_PID FECHAAPORTADOPID,t1.OID_DOKUSI OIDDOKUSI,t1.APORTADO_EXPEDIENTE APORTADOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM DOCUMENTOS_SUBIDOS t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto,
				DocumentosSubidos.class, filterParamList, searchSQL, searchParamList, from_alias,
				"ID_DOCUMENTO_SUBIDO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<DocumentosSubidos>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	@Override
	public void removeMultiple(DocumentosSubidos filterdocumentosSubidos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO,t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t1.OID_PID OIDPID,t1.FECHA_APORTADO_PID FECHAAPORTADOPID,t1.OID_DOKUSI OIDDOKUSI,t1.APORTADO_EXPEDIENTE APORTADOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM DOCUMENTOS_SUBIDOS t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterdocumentosSubidos, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto,
				DocumentosSubidos.class, query, params, "ID_DOCUMENTO_SUBIDO");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	@Override
	public List<JerarquiaDto<DocumentosSubidos>> findAllLikeJerarquia(DocumentosSubidos filterDocumentosSubidos,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DOCUMENTO_SUBIDO IDDOCUMENTOSUBIDO,t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t1.OID_PID OIDPID,t1.FECHA_APORTADO_PID FECHAAPORTADOPID,t1.OID_DOKUSI OIDDOKUSI,t1.APORTADO_EXPEDIENTE APORTADOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM DOCUMENTOS_SUBIDOS t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("DOCUMENTOS_SUBIDOS");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterDocumentosSubidos, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_DOCUMENTO_SUBIDO", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					DocumentosSubidosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	@Override
	public Long findAllLikeCountJerarquia(DocumentosSubidos filterDocumentosSubidos, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM DOCUMENTOS_SUBIDOS t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("DOCUMENTOS_SUBIDOS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterDocumentosSubidos, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_DOCUMENTO_SUBIDO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	@Override
	public List<TableRowDto<DocumentosSubidos>> findAllChild(DocumentosSubidos filterDocumentosSubidos,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM DOCUMENTOS_SUBIDOS t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("DOCUMENTOS_SUBIDOS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterDocumentosSubidos, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_DOCUMENTO_SUBIDO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<DocumentosSubidos>(this.rwMapPK, "ID_DOCUMENTO_SUBIDO"), params.toArray());
	}

	private Map<String, ?> getWhereMap(DocumentosSubidos documentosSubidos) {

		StringBuilder where = new StringBuilder(DocumentosSubidosDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (documentosSubidos != null && documentosSubidos.getIdDocumentoSubido() != null) {
			where.append(" AND t1.ID_DOCUMENTO_SUBIDO = ?");
			params.add(documentosSubidos.getIdDocumentoSubido());
		}
		if (documentosSubidos != null && documentosSubidos.getTipoPlantilla() != null
				&& documentosSubidos.getTipoPlantilla().getIdTipoPlantilla() != null) {
			where.append(" AND t1.ID_TIPO_PLANTILLA = ?");
			params.add(documentosSubidos.getTipoPlantilla().getIdTipoPlantilla());
		}
		if (documentosSubidos != null && documentosSubidos.getNombreDocumento() != null) {
			where.append(" AND t1.NOMBRE_DOCUMENTO = ?");
			params.add(documentosSubidos.getNombreDocumento());
		}
		if (documentosSubidos != null && documentosSubidos.getOidPid() != null) {
			where.append(" AND t1.OID_PID = ?");
			params.add(documentosSubidos.getOidPid());
		}
		if (documentosSubidos != null && documentosSubidos.getFechaAportadoPid() != null) {
			where.append(" AND t1.FECHA_APORTADO_PID = ?");
			params.add(documentosSubidos.getFechaAportadoPid());
		}
		if (documentosSubidos != null && documentosSubidos.getOidDokusi() != null) {
			where.append(" AND t1.OID_DOKUSI = ?");
			params.add(documentosSubidos.getOidDokusi());
		}
		if (documentosSubidos != null && documentosSubidos.getAportadoExpediente() != null) {
			where.append(" AND t1.APORTADO_EXPEDIENTE = ?");
			params.add(documentosSubidos.getAportadoExpediente());
		}
		if (documentosSubidos != null && documentosSubidos.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(documentosSubidos.getFechaRegistro());
		}
		if (documentosSubidos != null && documentosSubidos.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(documentosSubidos.getUsuarioRegistro());
		}
		if (documentosSubidos != null && documentosSubidos.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(documentosSubidos.getFechaUltmodificacion());
		}
		if (documentosSubidos != null && documentosSubidos.getUsuarioUltmodificacion() != null) {
			where.append(" AND t1.USUARIO_ULTMODIFICACION = ?");
			params.add(documentosSubidos.getUsuarioUltmodificacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the DocumentosSubidos entity
	 *
	 * @param documentosSubidos
	 *            DocumentosSubidos Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(DocumentosSubidos documentosSubidos, Boolean startsWith) {

		StringBuilder where = new StringBuilder(DocumentosSubidosDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (documentosSubidos != null && documentosSubidos.getIdDocumentoSubido() != null) {
			where.append(" AND t6152.ID_DOCUMENTO_SUBIDO = ?");
			params.add(documentosSubidos.getIdDocumentoSubido());
		}
		if (documentosSubidos != null && documentosSubidos.getIdActuacion() != null) {
			where.append(" AND t7929.ID_ACTUACION = ?");
			params.add(documentosSubidos.getIdActuacion());
		}
		if (documentosSubidos != null && documentosSubidos.getTipoPlantilla() != null
				&& documentosSubidos.getTipoPlantilla().getIdTipoPlantilla() != null) {
			where.append(" AND t6152.ID_TIPO_PLANTILLA = ?");
			params.add(documentosSubidos.getTipoPlantilla().getIdTipoPlantilla());
		}
		if (documentosSubidos != null && documentosSubidos.getNombreDocumento() != null) {
			where.append(" AND UPPER(t6152.NOMBRE_DOCUMENTO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(documentosSubidos.getNombreDocumento().toUpperCase() + "%");
			} else {
				params.add("%" + documentosSubidos.getNombreDocumento().toUpperCase() + "%");
			}
			where.append(" AND t6152.NOMBRE_DOCUMENTO IS NOT NULL");
		}
		if (documentosSubidos != null && documentosSubidos.getOidPid() != null) {
			where.append(" AND UPPER(t6152.OID_PID) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(documentosSubidos.getOidPid().toUpperCase() + "%");
			} else {
				params.add("%" + documentosSubidos.getOidPid().toUpperCase() + "%");
			}
			where.append(" AND t6152.OID_PID IS NOT NULL");
		}
		if (documentosSubidos != null && documentosSubidos.getFechaAportadoPid() != null) {
			where.append(" AND t6152.FECHA_APORTADO_PID = ?");
			params.add(documentosSubidos.getFechaAportadoPid());
		}
		if (documentosSubidos != null && documentosSubidos.getOidDokusi() != null) {
			where.append(" AND UPPER(t6152.OID_DOKUSI) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(documentosSubidos.getOidDokusi().toUpperCase() + "%");
			} else {
				params.add("%" + documentosSubidos.getOidDokusi().toUpperCase() + "%");
			}
			where.append(" AND t6152.OID_DOKUSI IS NOT NULL");
		}
		if (documentosSubidos != null && documentosSubidos.getAportadoExpediente() != null) {
			where.append(" AND t6152.APORTADO_EXPEDIENTE = ?");
			params.add(documentosSubidos.getAportadoExpediente());
		}
		if (documentosSubidos != null && documentosSubidos.getFechaRegistro() != null) {
			where.append(" AND t6152.FECHA_REGISTRO = ?");
			params.add(documentosSubidos.getFechaRegistro());
		}
		if (documentosSubidos != null && documentosSubidos.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t6152.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(documentosSubidos.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + documentosSubidos.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t6152.USUARIO_REGISTRO IS NOT NULL");
		}
		if (documentosSubidos != null && documentosSubidos.getFechaUltmodificacion() != null) {
			where.append(" AND t6152.FECHA_ULTMODIFICACION = ?");
			params.add(documentosSubidos.getFechaUltmodificacion());
		}
		if (documentosSubidos != null && documentosSubidos.getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t6152.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(documentosSubidos.getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + documentosSubidos.getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t6152.USUARIO_ULTMODIFICACION IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
